from pytube import Playlist
url = 'https://www.youtube.com/watch?v=4ASVa2HPr6M&list=PL-c3IMzE1Ofo3QFnr2bUYsELEz4wcgTx3'
playlist = Playlist(url)
print('동영상 재생목록 수: %s' % len(playlist.video_urls))
print('재생목록 제목: %s' % playlist.title)
num = len(playlist.video_urls)

def on_progress(vid, chunk, bytes_remaining):
    total_size = vid.filesize
    bytes_downloaded = total_size - bytes_remaining
    percentage_of_completion = bytes_downloaded / total_size * 100
    totalsz = (total_size/1024)/1024
    totalsz = round(totalsz,1)
    remain = (bytes_remaining / 1024) / 1024
    remain = round(remain, 1)
    dwnd = (bytes_downloaded / 1024) / 1024
    dwnd = round(dwnd, 1)
    percentage_of_completion = round(percentage_of_completion,2)

    #print(f'Total Size: {totalsz} MB')
    print(f'Download Progress: {percentage_of_completion}%, Total Size:{totalsz} MB, Downloaded: {dwnd} MB, Remaining:{remain} MB')

path = './imsi'
i = 1
for video in playlist.videos: # playlist의 영상을 하나씩 돌면서
    video.register_on_progress_callback(on_progress) # 다운로드 상태를 보여주기 위해 사용자 정의 함수(on_progress())를 호출하고,
    video.streams.filter(res="360p").first().download(path) # 화질과 다운로드 패스를 지정 후
    print(i," 번째 동영상이 다운로드 되었습니다.","(",video.title,")\n") # 영상이 다운로드 되면 안내 메시지를 보여줌
    i = i + 1

print(num, "개의 동영상이 모두 다우로드 완료되었습니다.")